import {
    Http,
    HttpUrls,
    Tools,
    Theme,
} from "com-api";
import {ServiceCommon} from './../../ServiceCommon';

/**
 * 接口
 * **/
export class Service {


    static base;

    static retJson = {
        steps:[],//提示步骤名
        pageCode:null,//要进入页面的编码
        currentTaskId:null,//当前步骤ID，
        event_list:null,//操作事件数据数组
    };//后台返回数据

    constructor() {
        Service.base = this;
    }


    /**
     * 提交数据 urlPutInVisitAndResolve
     * @param selectedValue json,//提交数据
     * **/
    static putIn(selectedValue){
        console.log(selectedValue)
        return new Promise((resolve, reject) => {

            Http.post(HttpUrls.urlSets.urlAddReportImgPath,{selectedValue,type:202,key:'taskFollowupMatters',task_id:selectedValue.taskId})

            // task_id:taskId,
            //     type:202,
            //     key:'bussinesstrip_file',
            //     value:filePath

                .then(retJson=>{
                    ServiceCommon.goNextStep(this.retJson.id, this.retJson.currentTaskId)
                        .then((retJson)=>{
                            resolve(retJson);
                        });
                });

        });

    }



    /**
     * 获取当前步骤数据的详情
     * @param taskId string,//任务ID
     * **/
    static getCurStepDetail(taskId){

        return ServiceCommon.getCurStepDetail(taskId).then(retJson=>{
            this.retJson = retJson;
            return retJson;
        });
    }

    /**
     * 获取当前步骤数据的详情
     * @param taskId string,//任务ID
     * @param currentTaskId string,//当前步骤ID
     * **/
    static goNextStep(taskId,currentTaskId){
        return Http.post(HttpUrls.urlSets.urlStep, {
            currentTaskId:currentTaskId,//当前步骤ID
            taskId:taskId
        })
            .then((retJson)=>{
                return {
                    pageCode:retJson.retData.front_code,
                    currentTaskId:data.retData.id,
                    event_list:data.retData.event_list,
                };
            });
    }

}